/*
#include <cv.h>
#include <cxcore.h>
#pragma comment(lib, "cv210.lib") 
#pragma comment(lib, "cxcore210.lib") 
#pragma comment(lib,"highgui210.lib")
*/
#include <esplib.h>
#include <ewclib.h>     //cv.hŃCN[h

#define SOURCE 0
#define ORIG 1
#define ORIGTORGB 2
#define ORIGTOJPG 3
#define RGBTOJPG 4
#define DECODE 5
#define SAMPLE 6

int quality=70;

void ESP_Ready(void)
{
//        ESP_CreateImage(0,"Camera",0,0,640,480,100);
        ESP_OpenTextWindow(0,216,0,480,200);

		ESP_OpenButtonBox(0, 0, 2, 1);
		ESP_SetButtonBoxTitle(0, "apply");
		ESP_SetButtonBoxTitle(1, "break");

		ESP_OpenInputBox(0, 68, 1);
		ESP_SetInputBoxTitle(0, "JPEGQuality");
		ESP_SetInputBoxI(0, quality);

//        ESP_SetForeground(ESPMAINWINDOW);
        ESP_Printf("AiOtƂ`L[p\n");
        ESP_Printf("摜[PNG,BMP]hbv\n");
        ESP_Printf("StartNbN\n");
//	ESP_START=1;
}

 //char *CV_window_name[]="OpenCV window"



void ESP_Main(void)
{
int WX,WY;

if (ESP_GetDisplayMode(SOURCE)) {

	WX=esp_iw[SOURCE].wx;
	WY=esp_iw[SOURCE].wy;

        ESP_CreateImage(ORIG,"@F摜",0,0,WX,WY,100);
		ESP_PutWindow(ESP_VramPtr[SOURCE],0,0,WX,WY);
		ESP_DestroyImage(SOURCE);
//		ESP_ImageLoad("anaglyph.png",0,0,100);

retry:
		ESP_Select(ORIG);
		ESP_JpegQuality(quality);
		ESP_ImageSave(ESP_JPEG,"SRCtoJPEG.jpg",0,0,WX,WY);
		ESP_Update();

		ESP_CreateImage(ORIGTOJPG,"@jpgۑčĕ\",320,0,WX,WY,100);
		ESP_ImageLoad("SRCtoJPEG.jpg",0,0,100);
		ESP_Update();


#define XY2PT(x,y,widex) (((y)*(widex))+(x))

		int col;
		int r,g,b;
		ESP_CreateImage(ORIGTORGB,"AF@RGBɕ",0,300,WX*3,WY,100);
		for (int y=0;y<WY;y++){
			for (int x=0;x<WX;x++){
				C2RGB(ESP_VramPtr[ORIG][ XY2PT(x,y,WX) ],&r,&g,&b);
				ESP_VramPtr[ORIGTORGB][ XY2PT(x,y,WX*3) ]=RGB2C(r,r,r);
				ESP_VramPtr[ORIGTORGB][ XY2PT(x+WX,y,WX*3) ]=RGB2C(g,g,g);
				ESP_VramPtr[ORIGTORGB][ XY2PT(x+WX*2,y,WX*3) ]=RGB2C(b,b,b);
			}
		}

		ESP_Update();
		ESP_ImageSave(ESP_PNG,"RGB.png",0,0,WX*3,WY);
		ESP_JpegQuality(quality);
		ESP_ImageSave(ESP_JPEG,"RGBtoJPEG.jpg",0,0,WX*3,WY);

		ESP_CreateImage(RGBTOJPG,"BFAjpgۑčĕ\",0,600,WX*3,WY,100);
		ESP_ImageLoad("RGBtoJPEG.jpg",0,0,100);
		ESP_Update();

		ESP_CreateImage(DECODE,"BFh~ŃfR[h",640,0,WX,WY,100);
		for (int y=0;y<WY;y++){
			for (int x=0;x<WX;x++){
				r=ESP_VramPtr[RGBTOJPG][ XY2PT(x,y,WX*3) ]&0x000000ff;
				g=ESP_VramPtr[RGBTOJPG][ XY2PT(x+WX,y,WX*3) ]&0x000000ff;
				b=ESP_VramPtr[RGBTOJPG][ XY2PT(x+WX*2,y,WX*3) ]&0x000000ff;
				ESP_VramPtr[DECODE][ XY2PT(x,y,WX) ]=RGB2C(r,g,b);
			}
		}
/*
		ESP_CreateImage(SAMPLE,"subpixel png",640,0,320,240,100);
		for (int y=0;y<240;y++){
			for (int x=0;x<320;x++){
				C2RGB(ESP_VramPtr[ORIG][ XY2PT(x,y,320) ],&r,&g,&b);
				r=ESP_VramPtr[ORIGTORGB][ XY2PT(x,y,960) ]&0x000000ff;
				g=ESP_VramPtr[ORIGTORGB][ XY2PT(x+320,y,960) ]&0x000000ff;
				b=ESP_VramPtr[ORIGTORGB][ XY2PT(x+640,y,960) ]&0x000000ff;
				ESP_VramPtr[SAMPLE][ XY2PT(x,y,320) ]=RGB2C(r,g,b);
			}
		}
*/


		ESP_Update();
		ESP_SetForeground(ESPBUTTONBOX);
		ESP_SetForeground(ESPINPUTBOX);
		

		while(1){
			quality = ESP_GetInputBoxI(0);
			if (quality<0){
				quality=0;
				ESP_SetInputBoxI(0, quality);
			}
			if (quality>100){
				quality=100;
				ESP_SetInputBoxI(0, quality);
			}
			if (ESP_GetButtonBox(0)) {
				ESP_DestroyImage(ORIGTORGB);
				ESP_DestroyImage(ORIGTOJPG);
				ESP_DestroyImage(RGBTOJPG);
				ESP_DestroyImage(DECODE);
				goto retry;
			}
			if (ESP_GetButtonBox(1)) {
				ESP_DestroyImage(ORIG);
				ESP_DestroyImage(ORIGTORGB);
				ESP_DestroyImage(ORIGTOJPG);
				ESP_DestroyImage(RGBTOJPG);
				ESP_DestroyImage(DECODE);
				goto end;
			}

			ESP_Sleep(100);
		}

} else {
		ESP_Pause("摜hbOĉ");
}
end:
;
}//main

void ESP_Finish(void)
{
}